#include "app_net.h"
#include "CH57x_common.h"
#include "stdint.h"
#include "CH57xBLE_LIB.H"
#include "CH57xNET.h"







uint8_t app_net_task_id;


#define KEEPLIVE_ENABLE                      1                                  /* KEEPLIVE */

/* ĻȫֱҪ壬е */
__align(16)UINT8    CH57xMACRxDesBuf[(RX_QUEUE_ENTRIES )*16];                   /* MAC16ֽڶ */
__align(4) UINT8    CH57xMACRxBuf[RX_QUEUE_ENTRIES*RX_BUF_SIZE];                /* MACջ4ֽڶ */
__align(4) SOCK_INF SocketInf[CH57xNET_MAX_SOCKET_NUM];                         /* SocketϢ4ֽڶ */

UINT16 MemNum[8] = {CH57xNET_NUM_IPRAW,
                    CH57xNET_NUM_UDP,
                    CH57xNET_NUM_TCP,
                    CH57xNET_NUM_TCP_LISTEN,
                    CH57xNET_NUM_TCP_SEG,
                    CH57xNET_NUM_IP_REASSDATA,
                    CH57xNET_NUM_PBUF,
                    CH57xNET_NUM_POOL_BUF
                    };
 UINT16 MemSize[8] = {CH57xNET_MEM_ALIGN_SIZE(CH57xNET_SIZE_IPRAW_PCB),
                    CH57xNET_MEM_ALIGN_SIZE(CH57xNET_SIZE_UDP_PCB),
                    CH57xNET_MEM_ALIGN_SIZE(CH57xNET_SIZE_TCP_PCB),
                    CH57xNET_MEM_ALIGN_SIZE(CH57xNET_SIZE_TCP_PCB_LISTEN),
                    CH57xNET_MEM_ALIGN_SIZE(CH57xNET_SIZE_TCP_SEG),
                    CH57xNET_MEM_ALIGN_SIZE(CH57xNET_SIZE_IP_REASSDATA),
                    CH57xNET_MEM_ALIGN_SIZE(CH57xNET_SIZE_PBUF) + CH57xNET_MEM_ALIGN_SIZE(0),
                    CH57xNET_MEM_ALIGN_SIZE(CH57xNET_SIZE_PBUF) + CH57xNET_MEM_ALIGN_SIZE(CH57xNET_SIZE_POOL_BUF)
                    };
__align(4)UINT8 Memp_Memory[CH57xNET_MEMP_SIZE];
__align(4)UINT8 Mem_Heap_Memory[CH57xNET_RAM_HEAP_SIZE];
__align(4)UINT8 Mem_ArpTable[CH57xNET_RAM_ARP_TABLE_SIZE];
/******************************************************************************/
/* ʾغ */
#define RECE_BUF_LEN                          536                               /* ջĴС */
/* CH57xNETTCPMSSΪ536ֽڣһTCPݲΪ536ֽ */
/* TCPЭջûڽأֵΪsocketĽջȡ趨 */
/* RX_QUEUE_ENTRIESʱҪMSSʹ֮Ĺϵ細ֵΪ4*MSSԶһλᷢ */
/* 4TCPRX_QUEUE_ENTRIESС4ȻᵼݰʧӶͨѶЧʽ */
/* RX_QUEUE_ENTRIESҪ( /MSS ),socketͬʱдݣ */ 
/* RX_QUEUE_ENTRIESҪ(( /MSS )*socket) ڶsocketͬʱдշʱ */
/* Ϊ˽ԼRAM뽫ջĳΪMSS */
																		
/* CH579ض */
UINT8 MACAddr[6] = {0x84,0xc2,0xe4,0x02,0x03,0x04};                             /* CH579MACַ */
UINT8 IPAddr[4] = {192,168,1,200};                                                          /* CH579IPַ */
UINT8 GWIPAddr[4] = {192,168,1,1};                                              /* CH579 */
UINT8 IPMask[4] = {255,255,255,0};                                              /* CH579 */
UINT8 DESIP[4] = {192,168,1,100};                                               /* ĿIPַ */

/* ڵƶ PBڵʮλЧ */
UINT16 CH57xNET_LEDCONN=0x0010;                                                 /* ָʾ PB4 */
UINT16 CH57xNET_LEDDATA=0x0080;                                                 /* ͨѶָʾ PB7 */ 

UINT8 SocketId;                                                                 /* socketԲö */
UINT8 SocketRecvBuf[RECE_BUF_LEN];                                              /* socketջ */
UINT8 MyBuf[RECE_BUF_LEN];                                                      /* һʱ */


UINT8 CH57xNET_DHCPCallBack(UINT8 status,void *arg);
//extern const UINT16 *memp_num;

/*******************************************************************************
* Function Name  : IRQ_Handler
* Description    : IRQжϷ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void ETH_IRQHandler( void )						                             	/* ̫ж */
{
	CH57xNET_ETHIsr();								                            /* ̫жжϷ */
}

//void TMR0_IRQHandler( void ) 						                            /* ʱж */
//{
//	CH57xNET_TimeIsr(CH57xNETTIMEPERIOD);                                       /* ʱжϷ */
//	R8_TMR0_INT_FLAG |= 0xff;						                            /* ʱжϱ־ */
//}



/*******************************************************************************
* Function Name  : mStopIfError
* Description    : ʹãʾ
* Input          : iError 
* Output         : None
* Return         : None
*******************************************************************************/
void mStopIfError(UINT8 iError)
{
    if (iError == CH57xNET_ERR_SUCCESS) return;                                 /* ɹ */
    PRINT("mStopIfError: %02X\r\n", (UINT16)iError);                            /* ʾ */
}


/*******************************************************************************
* Function Name  : CH57xNET_CreatTcpSocket
* Description    : TCP Client socket
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CH57xNET_CreatTcpSocket(void)
{
   UINT8 i;                                                             
   SOCK_INF TmpSocketInf;                                                       /* ʱsocket */

   memset((void *)&TmpSocketInf,0,sizeof(SOCK_INF));                            /* ڲὫ˱ƣýʱȫ */
   memcpy((void *)TmpSocketInf.IPAddr,DESIP,4);                                 /* ĿIPַ */
   TmpSocketInf.DesPort = 1000;                     
   TmpSocketInf.SourPort = 2000;                                                /* Դ˿ */
   TmpSocketInf.ProtoType = PROTO_TYPE_TCP;                                     /* socekt */
   TmpSocketInf.RecvStartPoint = (UINT32)SocketRecvBuf;                         /* ýջĽջ */
   TmpSocketInf.RecvBufLen = RECE_BUF_LEN ;                                     /* ýջĽճ */
   i = CH57xNET_SocketCreat(&SocketId,&TmpSocketInf);                           /* socketصsocketSocketId */
   mStopIfError(i);                                                             /*  */
#ifdef  KEEPLIVE_ENABLE
   CH57xNET_SocketSetKeepLive( SocketId, 1 );                                   /* socketKEEPLIVEܣV06汾֧֣ */
#endif

   i = CH57xNET_SocketConnect(SocketId);                                        /* TCP */
   mStopIfError(i);                                                             /*  */
   i = CH57xNET_SetSocketTTL( SocketId,128 );
   mStopIfError(i);                                                             /*  */
}


/*******************************************************************************
* Function Name  : net_initkeeplive
* Description    : keepliveʼ
* Input          : None      
* Output         : None
* Return         : None
*******************************************************************************/
#ifdef  KEEPLIVE_ENABLE
void net_initkeeplive(void)
{
    struct _KEEP_CFG  klcfg;

    klcfg.KLIdle = 20000;                                                       /*  */
    klcfg.KLIntvl = 10000;                                                      /*  */
    klcfg.KLCount = 5;                                                          /*  */
    CH57xNET_ConfigKeepLive(&klcfg);
}
#endif

/*******************************************************************************
* Function Name  : CH57xNET_LibInit
* Description    : ʼ
* Input          : ip      ipַָ
*                gwip    ipַָ
*                : mask    ָ
*                : macaddr MACַָ 
* Output         : None
* Return         : ִ״̬
*******************************************************************************/
UINT8 CH57xNET_LibInit(/*const*/ UINT8 *ip,/*const*/ UINT8 *gwip,/*const*/ UINT8 *mask,/*const*/ UINT8 *macaddr)
{
    UINT8 i;
    struct _CH57x_CFG cfg;

    if(CH57xNET_GetVer() != CH57xNET_LIB_VER)return 0xfc;                       /* ȡİ汾ţǷͷļһ */
    CH57xNETConfig = LIB_CFG_VALUE;                                             /* Ϣݸñ */
    cfg.RxBufSize = RX_BUF_SIZE; 
    cfg.TCPMss   = CH57xNET_TCP_MSS;
    cfg.HeapSize = CH57x_MEM_HEAP_SIZE;
    cfg.ARPTableNum = CH57xNET_NUM_ARP_TABLE;
    cfg.MiscConfig0 = CH57xNET_MISC_CONFIG0;
    CH57xNET_ConfigLIB(&cfg);
    i = CH57xNET_Init(ip,gwip,mask,macaddr);
#ifdef  KEEPLIVE_ENABLE
    net_initkeeplive( );
#endif
    return (i);                      
}

/*******************************************************************************
* Function Name  : CH57xNET_HandleSockInt
* Description    : Socketжϴ
* Input          : sockeid  socket
*                initstat ж״̬
* Output         : None
* Return         : None
*******************************************************************************/
void CH57xNET_HandleSockInt(UINT8 sockeid,UINT8 initstat)
{
    UINT32 len;
    UINT32 totallen;
    UINT8 *p = MyBuf;

    if(initstat & SINT_STAT_RECV)                                               /* ж */
    {
        len = CH57xNET_SocketRecvLen(sockeid,NULL);                             /* ѯ */
		PRINT("Receive Len = %d\r\n",len);                           
        totallen = len;
        CH57xNET_SocketRecv(sockeid,MyBuf,&len);                                /* ջݶMyBuf*/
        while(1)
        {
           len = totallen;
           CH57xNET_SocketSend(sockeid,p,&len);                                 /* MyBufеݷ */
           totallen -= len;                                                     /* ܳȼȥԼϵĳ */
           p += len;                                                            /* ָƫ*/
           if(totallen)continue;                                                /* δϣ*/
           break;                                                               /* ϣ˳ */
        }
    }
    if(initstat & SINT_STAT_CONNECT)                                            /* TCPж */
    {                                                                           /* жϱʾTCPѾӣԽշ */
        PRINT("TCP Connect Success\n");                           
    }
    if(initstat & SINT_STAT_DISCONNECT)                                         /* TCPϿж */
    {                                                                           /* жϣCH579ڲὫsocketΪر*/
        PRINT("TCP Disconnect\n");                                              /* Ӧ´ */
    }
    if(initstat & SINT_STAT_TIM_OUT)                                            /* TCPʱж */
    {                                                                           /* жϣCH579ڲὫsocketΪر*/
        PRINT("TCP Timout\n");                                                  /* Ӧ´ */

    }
}


/*******************************************************************************
* Function Name  : CH57xNET_HandleGloableInt
* Description    : ȫжϴ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CH57xNET_HandleGlobalInt(void)
{
    UINT8 initstat;
    UINT8 i;
    UINT8 socketinit;
    initstat = CH57xNET_GetGlobalInt();                                         /* ȫж״̬ */
    if(initstat & GINT_STAT_UNREACH)                                            /* ɴж */
    {
        PRINT("UnreachCode %d\n",CH57xInf.UnreachCode);                       /* 鿴ɴ */
        PRINT("UnreachProto %d\n",CH57xInf.UnreachProto);                     /* 鿴ɴЭ */
        PRINT("UnreachPort %d\n",CH57xInf.UnreachPort);                       /* ѯɴ˿ */       
    }
   if(initstat & GINT_STAT_IP_CONFLI)                                           /* IPͻж */
   {
   
   }
   if(initstat & GINT_STAT_PHY_CHANGE)                                          /* PHYıж */
   {
       i = CH57xNET_GetPHYStatus();                                             /* ȡPHY״̬ */
       PRINT("GINT_STAT_PHY_CHANGE %02x\n",i);
			 if(i > 1) { //0-> disconnected 
				 PRINT("start dhcp client \r\n");
				 CH57xNET_DHCPStart(CH57xNET_DHCPCallBack); 
			 }
   }
   if(initstat & GINT_STAT_SOCKET)                                              /* Socketж */
   {
       for(i = 0; i < CH57xNET_MAX_SOCKET_NUM; i ++)                     
       {
           socketinit = CH57xNET_GetSocketInt(i);                               /* socketжϲ */
           if(socketinit)CH57xNET_HandleSockInt(i,socketinit);                  /* ж */
       }    
   }
}

/*******************************************************************************
* Function Name  : Timer0Init
* Description    : ʱ1ʼ
* Input          : time ʱʱ
* Output         : None
* Return         : None
*******************************************************************************/
void Timer0Init(UINT32 time)
{
	R8_TMR0_CTRL_MOD = RB_TMR_ALL_CLEAR;	                                    /* мֵ */
	R8_TMR0_CTRL_MOD = 0;					                                	/* öʱģʽ */
	R32_TMR0_CNT_END = FREQ_SYS/1000000*time;	                                /* öʱʱ */
	R8_TMR0_INT_FLAG = R8_TMR0_INT_FLAG;		                                /* ־ */
	R8_TMR0_INTER_EN = RB_TMR_IE_CYC_END;	                                 	/* ʱж */
	R8_TMR0_CTRL_MOD |= RB_TMR_COUNT_EN;
	NVIC_EnableIRQ(TMR0_IRQn);	
}


/*******************************************************************************
* Function Name  : CH57xNET_DHCPCallBack
* Description    : DHCPص
* Input          : None
* Output         : None
* Return         : ִ״̬
*******************************************************************************/
UINT8 CH57xNET_DHCPCallBack(UINT8 status,void *arg)
{
   UINT8 *p;
   
   if(!status){                                                                  /* ɹ*/
       p = arg;                                                                  /* жϣCH57xNETڲὫsocketΪر*/
       PRINT("DHCP Success\n");
       memcpy(IPAddr,p,4);
       memcpy(GWIPAddr,&p[4],4);
       memcpy(IPMask,&p[8],4);                                                   /* жϣCH57xNETڲὫsocketΪر*/
       PRINT("IPAddr = %d.%d.%d.%d \n",(UINT16)IPAddr[0],(UINT16)IPAddr[1],
              (UINT16)IPAddr[2],(UINT16)IPAddr[3]);
       PRINT("GWIPAddr = %d.%d.%d.%d \n",(UINT16)GWIPAddr[0],(UINT16)GWIPAddr[1],
              (UINT16)GWIPAddr[2],(UINT16)GWIPAddr[3]);
       PRINT("IPAddr = %d.%d.%d.%d \n",(UINT16)IPMask[0],(UINT16)IPMask[1],
              (UINT16)IPMask[2],(UINT16)IPMask[3]);
       PRINT("DNS1: %d.%d.%d.%d\n",p[12],p[13],p[14],p[15]);
       PRINT("DNS2: %d.%d.%d.%d\n",p[16],p[17],p[18],p[19]);
//     CH57xNET_CreatTcpSocket();                                                /* ڴ˴DHCPɺTCP */
//	   PRINT("creat tcp sockrt!\r\n"); 
   }
   else{ 
                                                                                 /* жϣCH57xNETڲὫsocketΪر*/
      PRINT("DHCP Fail %02x\n",status);
   }  
	 PRINT("dhcp stop \r\n");
		CH57xNET_DHCPStop();	 
   return 0;
}

static void app_net_ProcessOSALMsg( tmos_event_hdr_t *pMsg ) {
    switch ( pMsg->event ) {
    case GATT_MSG_EVENT:
        break;

    default:
        break;
    }
}



uint16 app_net_process_event( uint8 task_id, uint16 events ) {

//  VOID task_id; // OSAL required parameter that isn't used in this function

    if ( events & SYS_EVENT_MSG ) {
        uint8 *pMsg;
        if ( (pMsg = tmos_msg_receive( app_net_task_id )) != NULL ) {
            app_net_ProcessOSALMsg( (tmos_event_hdr_t *)pMsg );
            // Release the OSAL message
            tmos_msg_deallocate( pMsg );
        }
        // return unprocessed events
        return (events ^ SYS_EVENT_MSG);
    }
    if ( events & APP_NET_START_EVT ) {
        PRINT("APP NET START_EVT\r\n");
        tmos_start_reload_task( app_net_task_id, APP_NET_TIMES_10_MS,16 );
        tmos_start_reload_task( app_net_task_id, APP_NET_TIMES_TICK,4 );

        tmos_start_task(app_net_task_id,APP_NET_TCP_RESTART,1600);
        //tmos_start_reload_task( app_net_task_id, APP_NET_TIMES_TEST,1600);
        return ( events ^ APP_NET_START_EVT );
    }
    if( events & APP_NET_TIMES_10_MS) {
        //PRINT("12\r\n");
        CH57xNET_TimeIsr(CH57xNETTIMEPERIOD);                                              /* ʱжϷ */
        //R8_TMR0_INT_FLAG |= 0xff;						                                   /* ʱжϱ־ */
        return ( events ^ APP_NET_TIMES_10_MS );
    }
    if(events & APP_NET_TIMES_TICK) {
        CH57xNET_MainTask();                                                    /* CH57xNETҪѭвϵ */
        if(CH57xNET_QueryGlobalInt())CH57xNET_HandleGlobalInt();                /* ѯжϣжϣȫжϴ */
        return ( events ^ APP_NET_TIMES_TICK );
    }
    if( events & APP_NET_TCP_RESTART) {

        PRINT("CH57xNET_CreatTcpSocket\r\n");
        PRINT("socket id %d\r\n",SocketId);
        //if(SocketId)
        CH57xNET_CreatTcpSocket();
        return (events ^ APP_NET_TCP_RESTART);
    }

    if(events & APP_NET_TIMES_TEST) {


        return (events ^ APP_NET_TIMES_TEST);
    }
    // Discard unknown events
    return 0;
}


/*******************************************************************************
* Function Name  : GetMacAddr
* Description    : ϵͳȡMACַ
* Input          : pMAC:ָ洢MacַĻ
* Output         : None
* Return         : None
*******************************************************************************/
void GetMacAddr(UINT8 *pMAC)
{
	UINT8 transbuf[6],i;
	
	GetMACAddress(transbuf);
	for(i=0;i<6;i++)
	{
		pMAC[5-i]=transbuf[i];
	
	}
}
void app_net_init(void) {
		uint8_t i;
    //when use ethernet must enable PLL at first
    PWR_UnitModCfg(ENABLE, UNIT_SYS_PLL);

    app_net_task_id = TMOS_ProcessEventRegister(app_net_process_event);
	
		GetMacAddr(MACAddr);                                                        /* ȡMACַ */
		i = CH57xNET_LibInit(IPAddr,GWIPAddr,IPMask,MACAddr);                       /* ʼ */
		mStopIfError(i);                                                            /*  */
		PRINT("CH57xNETLibInit Success\r\n");  
	
		NVIC_EnableIRQ(ETH_IRQn);	
    tmos_set_event( app_net_task_id, APP_NET_START_EVT );
}

