/********************************** (C) COPYRIGHT *******************************
* File Name          : main.c
* Author             : WCH
* Version            : V1.1
* Date               : 2019/11/05
* Description        : ӻӦϵͳʼ
*******************************************************************************/

/******************************************************************************/
/* ͷļ */
#include "CONFIG.h"
#include "CH57x_common.h"
#include "HAL.h"

#include "peripheral.h"

#include "stdbool.h"
#include "app_net.h"


/*********************************************************************
 * GLOBAL TYPEDEFS
 */
__align(4) u32 MEM_BUF[BLE_MEMHEAP_SIZE/4];

#if (defined (BLE_MAC)) && (BLE_MAC == TRUE)
u8C MacAddr[6] = {0x84,0xC2,0xE4,0xFF,0x02,0x06};
#endif



extern void app_uart_process(void);
extern void app_uart_init(void);


/*******************************************************************************
* Function Name  : main
* Description    : 
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
int main( void ) {
#ifdef DEBUG
    GPIOA_SetBits(bTXD1);
    GPIOA_ModeCfg(bTXD1, GPIO_ModeOut_PP_5mA);
    UART1_DefInit( );
#endif
    PRINT("%s\n",VER_LIB);
    CH57X_BLEInit( );

    HAL_Init( );
    GAPRole_PeripheralInit( );
    Peripheral_Init( );
    app_net_init();
    while(1) {
        TMOS_SystemProcess( );
    }
}

/******************************** endfile @ main ******************************/
